[tool.poetry]
name = "tbc-utils"
version = "0.1.0"
description = "TBC internal utility tools"
authors = ["Pierre Smeyers <pierre.smeyers@gmail.com>"]
license = "LGPL"
readme = "README.md"
packages = [{include = "tbc"}]

[tool.poetry.dependencies]
python = "^3.9"
pyyaml = "^6.0.1"
pydantic = "^2.4.2"

[build-system]
requires = ["poetry-core"]
build-backend = "poetry.core.masonry.api"

[tool.poetry.scripts]
t2c = "tbc.template_to_component:migrate"

[tool.poetry.group.dev.dependencies]
# new development dependencies can be added with 'poetry add -D yyy'
pytest = "^7.0.0"
pytest-cov = "^4.0.0"
pytest-env = "^0.8.0"
black = "^21.12b0"
mypy = "^1.0.0"
pylint = "^2.17.5"

[tool.pytest.ini_options]
# this project uses "pytest" for unit testing
# see: https://docs.pytest.org/en/6.2.x/customize.html#pyproject-toml
testpaths = [
    "tests",
]

[tool.black]
# this project uses "Black" as code formatter
# see: https://black.readthedocs.io/en/stable/usage_and_configuration/the_basics.html#usage
line-length = 88
target-version = ['py310']
include = '\.pyi?$'

[tool.mypy]
# this project uses "mypy" as a static type checker
# see: https://mypy.readthedocs.io/en/stable/config_file.html
python_version = 3.10
warn_return_any = true
warn_unused_configs = true
disallow_untyped_defs = true

[[tool.mypy.overrides]]
# loosen rules for tests
module = "tests.*"
warn_return_any = false
disallow_untyped_defs = false

[tool.pylint.messages_control]
max-line-length = 88
disable = [
  "missing-docstring",
#   "unused-argument",
#   "no-value-for-parameter",
#   "no-member",
#   "no-else-return",
#   "bad-whitespace",
#   "bad-continuation",
#   "line-too-long",
#   "fixme",
#   "protected-access",
   "too-few-public-methods",
#   "unspecified-encoding",
#   "redefined-outer-name"
]
